Package com.google.javascript.rhino.jstype

# Enum JSTypeRegistry.ResolveMode

java.lang.Object
java.lang.Enum<JSTypeRegistry.ResolveMode>
com.google.javascript.rhino.jstype.JSTypeRegistry.ResolveMode

All Implemented Interfaces:
  `Serializable`, `Comparable<JSTypeRegistry.ResolveMode>`, `java.lang.constant.Constable`

Enclosing class:
  `JSTypeRegistry`

public static enum JSTypeRegistry.ResolveMode extends Enum<JSTypeRegistry.ResolveMode>
The type registry has three modes, which control how type ASTs are converted to types in `JSTypeRegistry.createFromTypeNodes(com.google.javascript.rhino.Node, java.lang.String, com.google.javascript.rhino.jstype.StaticScope<com.google.javascript.rhino.jstype.JSType>)`.

## Nested Class Summary

## Nested classes/interfaces inherited from class java.lang.Enum

`Enum.EnumDesc<E extends Enum<E>>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`IMMEDIATE`
Expressions and type names are evaluated aggressively.
`LAZY_EXPRESSIONS`
Expressions are converted into Unknown blobs that can be resolved into complex types.
`LAZY_NAMES`
Expressions are evaluated.

## Method Summary

Modifier and Type
Method
Description
`static JSTypeRegistry.ResolveMode`
`valueOf(String name)`
Returns the enum constant of this type with the specified name.
`static JSTypeRegistry.ResolveMode[]`
`values()`
Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### LAZY_EXPRESSIONS

public static final JSTypeRegistry.ResolveMode LAZY_EXPRESSIONS
Expressions are converted into Unknown blobs that can be resolved into complex types.

### LAZY_NAMES

public static final JSTypeRegistry.ResolveMode LAZY_NAMES
Expressions are evaluated. If any names in the expression point to unknown types, then we create a proxy `NamedType` structure until the type can be resolved. This is the legacy way of resolving ways, and may not exist in the future.

### IMMEDIATE

public static final JSTypeRegistry.ResolveMode IMMEDIATE
Expressions and type names are evaluated aggressively. A warning will be emitted if a type name fails to resolve to a real type.

## Method Details

### values

public static JSTypeRegistry.ResolveMode[] values()
Returns an array containing the constants of this enum type, in the order they are declared.

Returns:
  an array containing the constants of this enum type, in the order they are declared

### valueOf

public static JSTypeRegistry.ResolveMode valueOf(String name)
Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum type has no constant with the specified name
  `NullPointerException` - if the argument is null